#include <cstdlib>
#include <cstdio>
#include "list-lib.h"

void main()
{
  int x,scelta,nl=0,nl1=0;
  lista ls[NUM_L];
  bool result;
  elem_tab *tab;

  do
  {
    system("cls");
    puts("\nFunzioni disponibili\n");
    puts("\t 1 - Inserisci elemento\n");
    puts("\t 2 - Elimina elemento (la lista DEVE essere ordinata)\n");
    puts("\t 3 - Trova elemento\n");
    puts("\t 4 - Stampa lista\n");
    puts("\t 5 - Ordina lista\n");
    puts("\t 6 - Fondi le liste (le liste DEVONO essere ordinate)\n");
    puts("\t 7 - Calcola frequenza di occorrenza degli elementi\n");
    puts("\t 8 - Esci\n");
    do
    {
       printf("\rScelta = ");
       if(scanf("%d",&scelta)!=1)
       {
          fflush(stdin);
	      scelta=0;
       }
    } while ( (scelta<1)||(scelta>8) );
    
    if (scelta != 8)
    {
        printf("\nScegli lista (0..%d): ",NUM_L-1);
        if( (scanf("%d",&nl)!=1) || (nl<0 || nl>=NUM_L) )
        {
            printf("Scelta lista errata\n");
            fflush(stdin);
        }
        else
        {
            switch(scelta)
            {
                case 1:	printf("\nInserisci un elemento: ");
                        if(scanf("%d",&x)!=1)
                        {
                            printf("Valore inserito errato\n");
                            fflush(stdin);
                        }
                        else
                            ls[nl].push(x);
                
                        break;
                case 2:	printf("\nElemento da cancellare: ");
                        if(scanf("%d",&x)!=1)
                        {
                            printf("Valore inserito errato\n");
                            fflush(stdin);
                            result=false;
                        }
                        else
                            result=ls[nl].cancella(x);
                        if (result)
		                    printf("\nElemento cancellato in lista %d\n",nl);
                        else
		                    printf("\nElemento non presente  in lista %d\n",nl);
                        break;
                case 3:	printf("\nElemento da cercare: ");
                        if(scanf("%d",&x)!=1)
                        {
                            printf("Valore inserito errato\n");
                            fflush(stdin);
                            result=false;
                        }
                        else 
                            result=ls[nl].trova(x);
                        if (result)
		                    printf("\nElemento trovato in lista %d\n",nl);
                        else
		                    printf("\nElemento non presente in lista %d\n",nl);
                        break;
                case 4: printf("\nElementi inseriti in lista %d\n",nl);
                        ls[nl].stampa();
                        break;
                case 5: printf("\nOrdinamento lista %d...\n",nl);
                        ls[nl].ordina();
                  		printf("\nLista %d ordinata:\n",nl);
		                ls[nl].stampa();
                        break;
                case 6: printf("\nscegli l'altra lista da fondere: ");
                        if((scanf("%d",&nl1)!=1) || (nl1<0 || nl1>=NUM_L))
                        {
                            printf("Valori inseriti errati\n");
                            fflush(stdin);
                        }
                        else
                        {
                            ls[nl].fondi(ls[nl1]);
                            printf("\nLa lista ottenuta dopo la fusione e':\n");
		                    ls[nl].stampa();
                        }
		                break;
                case 7:  printf("\nFrequenza di occorrenza degli elementi della lista %d\n",nl);
                         tab=ls[nl].calcola_freq();
                         print_tab(tab);
                         break;  
            }  // end switch(scelta)
        }  // end else
    }  // end if(scelta != 8)
            
    system("pause");
  } while(scelta!=8);
}

